module SecondFactor
  class HOTP
    def self.generate(secret_based, step)
      hmac = SecondFactor::OTP.generate_hmac(secret_based, step)
      hotp = (hmac % 10 ** 6).to_s.rjust(6, '0')
      return hotp
    end

    def self.verify(secret_based, step, token)
      challenge = self.generate(secret_based, step)
      return challenge == token
    end
  end
end
